import java.util.ArrayList;

import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

public class ZahlenanalyseTest{
	private Zahlenanalyse zana42und23;
	private Zahlenanalyse zanaNull;
	private Zahlenanalyse zana23;

	@Before
	public void setUp() {
		ArrayList<Integer> l1 = new ArrayList<Integer>();
		l1.add(42);
		l1.add(23);
		zana42und23 = new Zahlenanalyse(l1);
		zanaNull = new Zahlenanalyse(null);
		ArrayList<Integer>l2 = new ArrayList<Integer>();
		l2.add(23);
		zana23 = new Zahlenanalyse(l2);
	}
	
	@Test
	public void testZahlenMitDreiAmEnde1(){
		Zahlenanalyse tmp = zana42und23.zahlenMitDreiAmEnde();
		Assert.assertTrue(tmp.getZahlen().size() == 1);
		Assert.assertTrue(tmp.getZahlen().get(0) == 23);
	}
	
	@Test
	public void testZahlenMitDreiAmEnde2(){
		Zahlenanalyse tmp = zanaNull.zahlenMitDreiAmEnde();
		Assert.assertTrue(tmp.getZahlen().size() == 0);
	}
	
	@Test
	public void testZahlenMitDreiAmEnde3(){
		Zahlenanalyse tmp = zana23.zahlenMitDreiAmEnde();
		Assert.assertTrue(tmp.getZahlen().size() == 1);
		Assert.assertTrue(tmp.getZahlen().get(0) == 23);
	}
	
	@Test
	public void testgibtGleiche1(){
		Boolean tmp = zana42und23.gibtGleiche(zanaNull);
		Assert.assertTrue(!tmp);
	}
	
	@Test
	public void testgibtGleiche2(){
		Boolean tmp = zana42und23.gibtGleiche(zana23);
		Assert.assertTrue(tmp);
	}
	
	@Test
	public void testgibtGleiche3(){
		Boolean tmp = zana23.gibtGleiche(zana42und23); 
		Assert.assertTrue(!tmp);     //?!?
	}
	
	@Test
	public void testIstPrimzahl1() {
		Boolean nicht42 = zana23.istPrimzahl(42);
		Assert.assertTrue("42 ist Primzahl", !nicht42);
	}
	
	@Test
	public void testIstPrimzahl2() {
		Boolean doch41 = zana23.istPrimzahl(41);
		Assert.assertTrue("41 ist keine Primzahl", doch41);
	}

	@After
	public void tearDown() {
	}
	
	/* Version 2
	private Zahlenanalyse zana;
	
	@Before
	public void setUp() {
		zana = new Zahlenanalyse(null);
	}
	
	@Test
	public void testIstPrimzahl1() {
		Boolean nicht42 = zana.istPrimzahl(42);
		Assert.assertTrue("42 ist Primzahl", !nicht42);
	}

	@Test
	public void testIstPrimzahl2() {
		Boolean doch41 = zana.istPrimzahl(41);
		Assert.assertTrue("41 ist keine Primzahl", doch41);
	}
	*/
	
	
	/* Version 1
	@Test
	public void testIstPrimzahl1() {
		Zahlenanalyse zana = new Zahlenanalyse(null);
		Boolean nicht42 = zana.istPrimzahl(42);
		Assert.assertTrue("42 ist Primzahl", !nicht42);
	}

	@Test
	public void testIstPrimzahl2() {
		Zahlenanalyse zana = new Zahlenanalyse(null);
		Boolean doch41 = zana.istPrimzahl(41);
		Assert.assertTrue("41 ist keine Primzahl", doch41);
	}
	*/
}
