import java.util.ArrayList;

public class Polygonzug{
    private ArrayList<Punkt> punkte;
    private boolean geschlossen = false;


    public Polygonzug(){
        this.punkte = new ArrayList<Punkt>();
    }
    
    public void setGeschlossen(boolean neu){
        this.geschlossen = neu;
    }

    public void hinzufuegen(Punkt p){
        this.punkte.add(p);
    }

    public void loeschenAnPosition(int pos){
        this.punkte.remove(pos);
    }

    public void anzeigen(Interaktionsbrett ib){
        int anzahl = this.punkte.size();
        int zaehler = 0;
        while(zaehler < anzahl-1){
            Punkt start = this.punkte.get(zaehler);
            Punkt ende = this.punkte.get(zaehler+1);
            ib.neueLinie(start.getX(),start.getY(),ende.getX(),ende.getY());
            zaehler = zaehler + 1;
        }   
        if(geschlossen == true && anzahl > 0){
            Punkt anfang = this.punkte.get(0);
            Punkt ende = this.punkte.get(this.punkte.size()-1);
            ib.neueLinie(anfang.getX(),anfang.getY(),ende.getX(),ende.getY());
        }
    }

    public void verschieben(int deltaX, int deltaY){
        int zaehler = 0;
        while(zaehler < this.punkte.size()){
            Punkt p = this.punkte.get(zaehler);
            p.verschieben(deltaX,deltaY);
            zaehler = zaehler + 1;
        }   
    }
    
    public Polygonzug nurNtePunkte(int n){
        Polygonzug ergebnis = new Polygonzug();
        int zaehler = 0;
        while(zaehler < this.punkte.size()){
            Punkt p = this.punkte.get(zaehler);
            ergebnis.hinzufuegen(p);
            zaehler = zaehler + n;
        }
        return ergebnis;
    }
}